
import random
import time

def charger_liste_mots(filename):
    '''charge un fichier sous forme de liste de chaînes de caractères'''
    l = []
    with open(filename) as f:
        content = f.read().splitlines()
        for line in content:
            l.append(line)
    return l

liste_mots = charger_liste_mots('listemots.txt')

def nb_occurences(mot, lettre):
    c = 0
    for car in mot:
        if car == lettre:
            c = c + 1
    return c

def sont_anagrammes1(mot1, mot2):
    for lettre in mot1:
        nb_occ = nb_occurences(mot1, lettre)
        if nb_occurences(mot2, lettre) != nb_occ:
            return False
    return True


def chaine_alea(n):
    """
    retourne une chaîne aléatoire composée de n caractères.
    """
    L = [chr(97 + random.randint(0, 1)) for _ in range(n)]
    return "".join(L)


def t(a):
    b = {}
    for _ in a:
        if _ in b:
            b[_] += 1
        else:
            b[_] = 1
    return b

def sont_anagrammes2(mot1, mot2):
    return t(mot1) == t(mot2)


def temps_evaluation(fonc, *args):
    """
    Utilisation :
        temps_evaluation(fonction, argument1, argument2, ....)
    Calcule et retourne le temps mis pour évaluer fonction(argument1, argument2, ...)
    Le nombre d'argument passé peut être 1 ou plus.

    Exemple:
        temps_evaluation(range, 0, 1000)
        temps_evaluation(np.sin, 1)
    """
    t0 = time.time()
    fonc(*args)
    return time.time() - t0

